unit WPTabEdit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Grids, Buttons;

type
  TWPTabForm = class(TForm)
    TabGrid: TStringGrid;
    OKButton: TBitBtn;
    CancelButton: TBitBtn;
    EqualButton: TSpeedButton;
    ClearButton: TSpeedButton;
    Label1: TLabel;
    Label2: TLabel;
    UnitLabel: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure EqualButtonClick(Sender: TObject);
    procedure ClearButtonClick(Sender: TObject);
    procedure TabGridKeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

implementation

uses WPRuler;

{$R *.DFM}

procedure TWPTabForm.FormCreate(Sender: TObject);
var
  N: Word;
begin
  with TabGrid do
  begin
    RowCount := MaxTabs + 1;
    ColWidths[1] := 45;
    for N := 1 to MaxTabs do
    begin
      Cells[0, N] := IntToStr(N);
      Cells[2, N] := 'L';
    end;
    Cells[0, 0] := 'Tab';
    Cells[1, 0] := 'Value';
    Cells[2, 0] := 'Style';
  end;
end;

procedure TWPTabForm.EqualButtonClick(Sender: TObject);
var
  N: Word;
  Value: Single;
  Style: string;
begin
  with TabGrid do
  if Cells[1, 1] > '' then
  begin
    Value := StrToFloat(Cells[1, 1]);
    Style := Cells[2, 1];
    for N := 2 to MaxTabs do
    begin
      Cells[1, N] := FloatToStrF(Value * N, ffGeneral, 5, 0);
      Cells[2, N] := Style;
    end;
  end;
end;

procedure TWPTabForm.ClearButtonClick(Sender: TObject);
var
  N: Integer;
begin
  for N := 1 to MaxTabs do
  begin
    TabGrid.Cells[1, N] := '0';
    TabGrid.Cells[2, N] := 'L';
  end;
end;

procedure TWPTabForm.TabGridKeyPress(Sender: TObject; var Key: Char);
begin
  with TabGrid do
  case Col of
    1: if not (Key in ['0'..'9', '.', #8]) then Key := #0;
    2: begin
         Key := UpCase(Key);
         if Key = #8 then Exit;
         if not (Key in ['L', 'C', 'R']) then Key := #0
         else if Cells[Col, Row] > '' then
         begin
           Cells[Col, Row] := Key;
           Key := #0;
         end;
       end;
  end;
end;

end.
